

<!DOCTYPE html>
<html>
<head>
<title>Обьекты Наминас</title>
<meta charset='utf-8'/>
</head>
<body>
 <script type="text/javascript">

// 1. Создать объект Point, содержащий два свойства: "x" и "y" — координаты точки, и метод GetQuadrant, вычисляющий, в каком квадранте в декартовой системе координат находится данная точка. Протестируйте данный объект, изменяя значения его координат, и повторно вызавая метод GetQuadrant.

    // делали на уроке
    
// 2. Создать объект Calculator, который должен содержать методы для расчета суммы, разности, произведения и частного двух чисел.
// Протестировать данный объект, принимая от пользователя значения двух операндов и знак операции. В зависимости от принятого знака операции, вызвать соответствующий метод.

    // делали на уроке

// 3. Создать массив, который будет хранить в себе информацию о сотрудниках предприятия. Каждый элемент масива — объект, содержащий свойства: name, sName, age, occupation, и метод show, который выводит всю информацию о пользователе.
// Реализовать заполнение массива пользователем. По окончанию заполнения — вывести информацию о сотрудниках.
    

    var workers=[];
    var l=+prompt('Сколько сотрудников хотите добавить?');
      for (var i=0;i<l;i++) {
        //var worker=new createWorker(); // создаем обьект
        // workers[i]=worker; // 1й способ добавления в массив объект
        //workers.push(worker); // 2й способ добавления в массив объект
        workers[i]=new createWorker(); // самый простой 3й способ создания в массиве обьекта
        workers[i].show(); 
      }      
      function createWorker () { // конструктор для объекта
        this.name=prompt('Имя '+(i+1)+' сотрудника:'), 
        this.sName=prompt('Фамилия '+(i+1)+' сотрудника:'), 
        this.age=+prompt('Возраст '+(i+1)+' сотрудника:'), 
        this.occupation=prompt('Должность '+(i+1)+' сотрудника:')


        this.show = function(){
          document.write("<br><b>Сотрудник:</b> Имя: "+this.sName+' Фамилия: '+this.name+'  Возраст: '+this.age+' Должность: '+this.occupation);
        }
    }

// 4. Для предыдущего задания создайте функцию, которая будет принимать в себя массив объектов-сотрудников, и каждому из объектов будет добавлять новое свойство "salary", хранящее зарплату сотрудника. 
//        Зарплата расчитывается, исходя из значения свойства "occupation" следующим образом:
//            • "director" — 3000;
//            • "manager" — 1500;
//            • "programmer" — 2000;
//            • для остальных значений — 1000.
// После выполнения функции — вывести информацию о сотрудниках.

document.write('<br><br><i>Task 4. Назначаем зарплату....</i><br>');
           
function addSalary (array) {
  for (var i=0; i < array.length; i++) {
    if (array[i].occupation=='director') array[i].salary=3000
    else if (array[i].occupation=='manager') array[i].salary=1500
    else if (array[i].occupation=='programmer') array[i].salary=2000
    else array[i].salary=1000;
    workers[i].show();
    document.write(' зарабатывает '+workers[i].salary+' грн');
  }
}
  addSalary(workers);

// 5. Для задания 3 создать метод, позволяющий отсортировать массив сотрудников по одному из свойств: name, sName, age, occupation, salary.
// Параметр для сортировки принимается от пользователя.
// После выполнения функции — вывести информацию о сотрудниках.
console.log(workers);
console.log('After');
var c=prompt('Укажите по какому свойству отсортировать массив - name - sName - age - occuparion - salary ');
sortWorkers(c);

 

function sortWorkers (choose) {

//выбираем имя
  if (choose=='name'){
    var temp=[];    //пустой массив, в котором буду сортировать свойства сотрудников
    for (var i=0; i<workers.length; i++) {temp[i]=workers[i].name;}  //     в массив темп переношу значения свойства всех сотрудников
            temp.sort(); // сортируем массив Темп
            for (var i=0; i<temp.length; i++) {
                for (var j=0;j<workers.length;j++) { 
                  if (temp[i]==workers[j].name) {temp[i]=workers[j]} // добавляю в Темп остальные свойства сотрудников
              }
              document.write('<br>---Отсортированный список по фамилии ---<br>');
              temp[i].show();
              document.write(', Зарплата: '+temp[i].salary+' грн');
            }
  }

  // выбираем фамилию
  else if (choose=='sName'){
     var temp=[];    //пустой массив, в котором буду сортировать свойства сотрудников
    for (var i=0; i<workers.length; i++) {temp[i]=workers[i].sName; } //в массив темп переношу значения свойства всех сотрудников
            temp.sort(); // сортируем массив Темп
            for (var i=0; i<temp.length; i++) {
                for (var j=0;j<workers.length;j++) { 
                  if (temp[i]==workers[j].sName) {temp[i]=workers[j]} // добавляю в Темп остальные свойства сотрудников
              }
              document.write('<br>---Отсортированный список по фамилии ---<br>');
              temp[i].show();
              document.write(', Зарплата: '+temp[i].salary+' грн');
            }
  }

  //выбираем возраст  
  else if (choose=='age'){
    var temp=[];    //пустой массив, в котором буду сортировать свойства сотрудников
    for (var i=0; i<workers.length; i++) {
            temp[i]=workers[i].age;       // создаю массив, в которые переношу значения свойства всех сотрудников
        }
            temp.sort(function(a,b){return a-b}); // сортируем массив Темп, в метод передаю функцию сравнения. сортируем по возрастанию
            for (var i=0; i<temp.length; i++) {
                for (var j=0;j<workers.length;j++) { 
                  if (temp[i]==workers[j].age) {temp[i]=workers[j]} // добавляю в Темп остальные свойства сотрудников
              }
              document.write('<br>---Отсортированный список по возрасту---<br>');
              temp[i].show();
              document.write(', Зарплата: '+temp[i].salary+' грн');
            }

  }
  else if (choose=='occupation'){ 
    // здесь можно поразному сделать - либо сортировать по названию должности либо по зарплате.  Код либо тот что для имени либо тот что для зарплаты


  }

    //выбираем зарплату
  else if (choose=='salary'){
    var temp=[];    //аналогично возрасту
    for (var i=0; i<workers.length; i++) {temp[i]=workers[i].salary;}
    temp.sort(function(a,b){return a-b}); 
      for (var i=0; i<temp.length; i++) {
        for (var j=0;j<workers.length;j++) { 
            if (temp[i]==workers[j].salary) {temp[i]=workers[j]} 
              }
              document.write('<br>---Отсортированный список по зарплате---<br>');
              temp[i].show();
              document.write(', Зарплата: '+temp[i].salary+' грн');
            }

  }
  else alert("Такого свойства не существует");


}





</script>
</body>
</html>